src/Entity/Game.php
<?php

namespace App\Entity;

use App\Repository\GameRepository;
use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use Doctrine\ORM\Mapping as ORM;

/**
 * @ORM\Entity(repositoryClass=GameRepository::class)
 */
class Game
{
    /**
     * @ORM\Id
     * @ORM\GeneratedValue
     * @ORM\Column(type="integer")
     */
    private $id;

    /**
     * @ORM\Column(type="string", length=100)
     */
    private $title_game;

    /**
     * @ORM\Column(type="text")
     */
    private $description_game;

    /**
     * @ORM\Column(type="date")
     */
    private $released_at;

    /**
     * @ORM\Column(type="string", length=255, nullable=true)
     */
    private $game_cover;

    /**
     * @ORM\Column(type="integer", nullable=true)
     */
    private $nb_sell_game;

    /**
     * @ORM\ManyToMany(targetEntity=Type::class, inversedBy="game")
     */
    private $type;

    /**
     * @ORM\ManyToMany(targetEntity=Platform::class, inversedBy="game")
     */
    private $platform;

    /**
     * @ORM\OneToMany(targetEntity=UserHasGame::class, mappedBy="game", orphanRemoval=true)
     */
    private $user_has_game;

    public function __construct()
    {
        $this->type = new ArrayCollection();
        $this->platform = new ArrayCollection();
        $this->user_has_name = new ArrayCollection();
        $this->user_has_game = new ArrayCollection();
    }

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getTitleGame(): ?string
    {
        return $this->title_game;
    }

    public function setTitleGame(string $title_game): self
    {
        $this->title_game = $title_game;

        return $this;
    }

    public function getDescriptionGame(): ?string
    {
        return $this->description_game;
    }

    public function setDescriptionGame(string $description_game): self
    {
        $this->description_game = $description_game;

        return $this;
    }

    public function getReleasedAt(): ?\DateTimeInterface
    {
        return $this->released_at;
    }

    public function setReleasedAt(\DateTimeInterface $released_at): self
    {
        $this->released_at = $released_at;

        return $this;
    }

    public function getGameCover(): ?string
    {
        return $this->game_cover;
    }

    public function setGameCover(?string $game_cover): self
    {
        $this->game_cover = $game_cover;

        return $this;
    }

    public function getNbSellGame(): ?int
    {
        return $this->nb_sell_game;
    }

    public function setNbSellGame(?int $nb_sell_game): self
    {
        $this->nb_sell_game = $nb_sell_game;

        return $this;
    }

    /**
     * @return Collection|type[]
     */
    public function getType(): Collection
    {
        return $this->type;
    }

    public function addType(type $type): self
    {
        if (!$this->type->contains($type)) {
            $this->type[] = $type;
        }

        return $this;
    }

    public function removeType(type $type): self
    {
        $this->type->removeElement($type);

        return $this;
    }

    /**
     * @return Collection|platform[]
     */
    public function getPlatform(): Collection
    {
        return $this->platform;
    }

    public function addPlatform(platform $platform): self
    {
        if (!$this->platform->contains($platform)) {
            $this->platform[] = $platform;
        }

        return $this;
    }

    public function removePlatform(platform $platform): self
    {
        $this->platform->removeElement($platform);

        return $this;
    }

    /**
     * @return Collection|userhasgame[]
     */
    public function getUserHasName(): Collection
    {
        return $this->user_has_name;
    }

    public function addUserHasName(userhasgame $userHasName): self
    {
        if (!$this->user_has_name->contains($userHasName)) {
            $this->user_has_name[] = $userHasName;
            $userHasName->setGame($this);
        }

        return $this;
    }

    public function removeUserHasName(userhasgame $userHasName): self
    {
        if ($this->user_has_name->removeElement($userHasName)) {
            // set the owning side to null (unless already changed)
            if ($userHasName->getGame() === $this) {
                $userHasName->setGame(null);
            }
        }

        return $this;
    }

    /**
     * @return Collection|userhasgame[]
     */
    public function getUserHasGame(): Collection
    {
        return $this->user_has_game;
    }

    public function addUserHasGame(userhasgame $userHasGame): self
    {
        if (!$this->user_has_game->contains($userHasGame)) {
            $this->user_has_game[] = $userHasGame;
            $userHasGame->setGame($this);
        }

        return $this;
    }

    public function removeUserHasGame(userhasgame $userHasGame): self
    {
        if ($this->user_has_game->removeElement($userHasGame)) {
            // set the owning side to null (unless already changed)
            if ($userHasGame->getGame() === $this) {
                $userHasGame->setGame(null);
            }
        }

        return $this;
    }
}

src/Form/GameType.php
<?php

namespace App\Form;

use App\Entity\Game;
use App\Entity\Platform;
use App\Entity\Type;
use Symfony\Bridge\Doctrine\Form\Type\EntityType;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\Extension\Core\Type\DateType;
use Symfony\Component\Form\Extension\Core\Type\FileType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;

class GameType extends AbstractType
{
    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        $builder
            ->add('title_game')
            ->add('description_game')
            ->add('released_at', DateType::class, [
                'widget' => 'single_text',
            ])
            ->add('game_cover',FileType::class, [
                    'mapped' => false,
                    'required' => false,
                ])
            ->add('nb_sell_game')
            ->add('type', EntityType::class,[
                'class' => Type::class,
                'choice_label' => 'title_type',
                'multiple' => true,
                'expanded' => true,
            ])
            ->add('platform', EntityType::class,[
                'class' => Platform::class,
                'choice_label' => 'name_plat',
                'multiple' => true,
                'expanded' => true,
            ])
        ;
    }

    public function configureOptions(OptionsResolver $resolver)
    {
        $resolver->setDefaults([
            'data_class' => Game::class,
        ]);
    }
}

src/Controller/GameController.php
<?php

namespace App\Controller;

use App\Entity\Game;
use App\Form\GameType;
use App\Repository\GameRepository;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;
use Symfony\Component\String\Slugger\SluggerInterface;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\IsGranted;

/**
 * @Route("/admin/game")
 */

class GameController extends AbstractController
{
    /**
     * @Route("/", name="game_index", methods={"GET"})
     */
    public function index(GameRepository $gameRepository): Response
    {
        return $this->render('game/index.html.twig', [
            'games' => $gameRepository->findAll(),
        ]);
    }

    /**
     * @Route("/new", name="game_new", methods={"GET","POST"})
     */
    public function new(Request $request, SluggerInterface $slugger): Response
    {
        $game = new Game();
        $form = $this->createForm(GameType::class, $game);
        $form->handleRequest($request);

        if ($form->isSubmitted() && $form->isValid()) {

            $gameFile = $form->get('game_cover')->getData();

            // this condition is needed because the 'brochure' field is not required
            // so the PDF file must be processed only when a file is uploaded
            if ($gameFile) {
                $originalFilename = pathinfo($gameFile->getClientOriginalName(), PATHINFO_FILENAME);
                // this is needed to safely include the file name as part of the URL
                $safeFilename = $slugger->slug($originalFilename);
                $newFilename = $safeFilename.'-'.uniqid().'.'.$gameFile->guessExtension();

                // Move the file to the directory where brochures are stored
                try {
                    $gameFile->move(
                        $this->getParameter('image_directory'),
                        $newFilename
                    );
                } catch (FileException $e) {
                    // ... handle exception if something happens during file upload
                }

                // updates the 'brochureFilename' property to store the PDF file name
                // instead of its contents
                $game->setGameCover($newFilename);
            }


            $entityManager = $this->getDoctrine()->getManager();
            $entityManager->persist($game);
            $entityManager->flush();

            return $this->redirectToRoute('game_index');
        }

        return $this->render('game/new.html.twig', [
            'game' => $game,
            'form' => $form->createView(),
        ]);
    }

    /**
     * @Route("/{id}", name="game_show", methods={"GET"})
     */
    public function show(Game $game): Response
    {
        return $this->render('game/show.html.twig', [
            'game' => $game,
        ]);
    }

    /**
     * @Route("/{id}/edit", name="game_edit", methods={"GET","POST"})
     */
    public function edit(Request $request, Game $game): Response
    {
        $form = $this->createForm(GameType::class, $game);
        $form->handleRequest($request);

        if ($form->isSubmitted() && $form->isValid()) {
            $this->getDoctrine()->getManager()->flush();

            return $this->redirectToRoute('game_index');
        }

        return $this->render('game/edit.html.twig', [
            'game' => $game,
            'form' => $form->createView(),
        ]);
    }

    /**
     * @Route("/{id}", name="game_delete", methods={"POST"})
     */
    public function delete(Request $request, Game $game): Response
    {
        if ($this->isCsrfTokenValid('delete'.$game->getId(), $request->request->get('_token'))) {
            $entityManager = $this->getDoctrine()->getManager();
            $entityManager->remove($game);
            $entityManager->flush();
        }

        return $this->redirectToRoute('game_index');
    }
}

templates/game/_delete_form.html.twig
<form method="post" action="{{ path('game_delete', {'id': game.id}) }}" onsubmit="return confirm('Are you sure you want to delete this item?');">
    <input type="hidden" name="_token" value="{{ csrf_token('delete' ~ game.id) }}">
    <button class="btn">Delete</button>
</form>

templates/game/_form.html.twig
<div class="mdl-grid mdl-cell mdl-cell--12-col-desktop mdl-cell--12-col-tablet mdl-cell--4-col-phone mdl-cell--top scroll-tab">

    <div class="mdl-cell mdl-cell--7-col-desktop mdl-cell--7-col-tablet mdl-cell--4-col-phone">
        <div class="mdl-card mdl-shadow--2dp">
            <div class="mdl-card__title">
                <h5 class="mdl-card__title-text text-color--white">Create new Game</h5>
            </div>

            <div class="mdl-card__supporting-text">

                {{ form_start(form) }}

                <div class="mdl-cell mdl-cell--6-col-desktop mdl-cell--6-col-tablet mdl-cell--4-col-phone form__article">
                    <div class="mdl-textfield mdl-js-textfield mdl-textfield--floating-label full-size">
                        {{ form_widget(form.title_game, { 'attr': {'class': 'mdl-textfield__input'} }) }}
                        <label class="mdl-textfield__label" for="floating-first-name">Title type</label>
                    </div>
                    <div class="mdl-textfield mdl-js-textfield mdl-textfield--floating-label full-size">
                        {{ form_widget(form.description_game, { 'attr': {'class': 'mdl-textfield__input'} }) }}
                        <label class="mdl-textfield__label" for="floating-last-name">Description</label>
                    </div>
                     <div class="mdl-textfield mdl-js-textfield mdl-textfield--floating-label full-size">
                        {{ form_widget(form.released_at, { 'attr': {'class': 'mdl-textfield__input'} }) }}
                    </div>
                    <div class="mdl-textfield mdl-js-textfield mdl-textfield--floating-label full-size">
                        {{ form_widget(form.game_cover, { 'attr': {'class': 'mdl-textfield__input'} }) }}
                    </div>
                    <div class="mdl-textfield mdl-js-textfield mdl-textfield--floating-label full-size">
                        {{ form_widget(form.nb_sell_game, { 'attr': {'class': 'mdl-textfield__input'} }) }}
                        <label class="mdl-textfield__label" for="floating-last-name">Number sell game</label>
                    </div>
                    <div class="mdl-textfield mdl-js-textfield mdl-textfield--floating-label full-size">
                        {{ form_widget(form.type, { 'attr': {'class': 'mdl-textfield__input'} }) }}
                    </div>
                    <div class="mdl-textfield mdl-js-textfield mdl-textfield--floating-label full-size">
                        {{ form_widget(form.platform, { 'attr': {'class': 'mdl-textfield__input'} }) }}
                    </div>
                    <button class="mdl-button mdl-js-button mdl-button--raised mdl-js-ripple-effect button--colored-light-blue">
                        {{ button_label|default('Save') }}
                    </button>
                    <div class="mdl-textfield mdl-js-textfield mdl-textfield--floating-label full-size">
                        <a href="{{ path('game_index') }}">back to list</a>
                    </div>
                </div>

                {{ form_end(form) }}

            </div>

        </div>
    </div>
</div>

templates/game/edit.html.twig
{% extends 'base.html.twig' %}

{% block title %}Edit Game{% endblock %}

{% block body %}
    <h1>Edit Game</h1>

    {{ include('game/_form.html.twig', {'button_label': 'Update'}) }}

    {{ include('game/_delete_form.html.twig') }}
{% endblock %}

templates/game/index.html.twig
{% extends 'base.html.twig' %}

{% block title %}Game index{% endblock %}

{% block body %}
    <h1>Game index</h1>

   {# <table class="table">
        <thead>
            <tr>
                <th>Id</th>
                <th>Title_game</th>
                <th>Description_game</th>
                <th>Released_at</th>
                <th>Game_cover</th>
                <th>Nb_sell_game</th>
                <th>actions</th>
            </tr>
        </thead>
        <tbody>
        {% for game in games %}
            <tr>
                <td>{{ game.id }}</td>
                <td>{{ game.titleGame }}</td>
                <td>{{ game.descriptionGame }}</td>
                <td>{{ game.releasedAt ? game.releasedAt|date('Y-m-d') : '' }}</td>
                <td><img class="logoPlatform" src="../uploads/image/{{ game.gameCover }}" alt=""></td>
                <td>{{ game.nbSellGame }}</td>
                <td>
                    <a href="{{ path('game_show', {'id': game.id}) }}">show</a>
                    <a href="{{ path('game_edit', {'id': game.id}) }}">edit</a>
                </td>
            </tr>
        {% else %}
            <tr>
                <td colspan="7">no records found</td>
            </tr>
        {% endfor %}
        </tbody>
    </table>#}

    <div class="mdl-cell mdl-cell--12-col-desktop mdl-cell--12-col-tablet mdl-cell--4-col-phone scroll-tab">
        <div class="mdl-card mdl-shadow--2dp">
            <div class="mdl-card__title">
                <h1 class="mdl-card__title-text">Advanced table</h1>
            </div>
            <div class="mdl-card__supporting-text no-padding">
                <table class="mdl-data-table mdl-js-data-table">
                    <thead>
                    <tr>
                        <th class="mdl-data-table__cell--non-numeric">Id</th>
                        <th class="mdl-data-table__cell--non-numeric">Title_game</th>
                        <th class="mdl-data-table__cell--non-numeric">Description_game</th>
                        <th class="mdl-data-table__cell--non-numeric">Released_at</th>
                        <th class="mdl-data-table__cell--non-numeric">Game_cover</th>
                        <th class="mdl-data-table__cell--non-numeric">Nb_sell_game</th>
                        <th class="mdl-data-table__cell--non-numeric">Type</th>
                        <th class="mdl-data-table__cell--non-numeric">Platform</th>
                        <th class="mdl-data-table__cell--non-numeric">actions</th>
                    </tr>
                    </thead>
                    <tbody>
                    {% for game in games %}
                    <tr>
                        <td class="mdl-data-table__cell--non-numeric">{{ game.id }}</td>
                        <td class="mdl-data-table__cell--non-numeric">{{ game.titleGame }}</td>
                        <td class="mdl-data-table__cell--non-numeric">{{ game.descriptionGame }}</td>
                        <td class="mdl-data-table__cell--non-numeric">{{ game.releasedAt ? game.releasedAt|date('Y-m-d') : '' }}</td>
                        <td class="mdl-data-table__cell--non-numeric"><img class="logoPlatform" src="/uploads/image/{{ game.gameCover }}" alt=""></td>
                        <td class="mdl-data-table__cell--non-numeric">{{ game.nbSellGame }}</td>
                        <td class="mdl-data-table__cell--non-numeric">
                            {% for type in game.type %}
                                {{ type.TitleType }}
                            {% endfor %}
                        </td>
                       <td class="mdl-data-table__cell--non-numeric">
                            {% for platform in game.platform %}
                                {{ platform.NamePlat }}
                            {% endfor %}
                        </td>
                        <td class="mdl-data-table__cell--non-numeric">
                            <a href="{{ path('game_show', {'id': game.id}) }}">show</a>
                            <a href="{{ path('game_edit', {'id': game.id}) }}">edit</a>
                        </td>
                    </tr>
                    {% else %}
                        <tr>
                            <td colspan="7">no records found</td>
                        </tr>
                    {% endfor %}
                    <tr>
                        <td colspan="0"> <a href="{{ path('game_new') }}">Create new</a> </td>
                    </tr>
                    </tbody>
                </table>
            </div>
        </div>
    </div>

{% endblock %}

templates/game/new.html.twig
{% extends 'base.html.twig' %}

{% block title %}New Game{% endblock %}

{% block body %}

    {{ include('game/_form.html.twig') }}

{% endblock %}

templates/game/show.html.twig
{% extends 'base.html.twig' %}

{% block title %}Game{% endblock %}

{% block body %}
    <h1>Game</h1>

    <table class="table">
        <tbody>
            <tr>
                <th>Id</th>
                <td>{{ game.id }}</td>
            </tr>
            <tr>
                <th>Title_game</th>
                <td>{{ game.titleGame }}</td>
            </tr>
            <tr>
                <th>Description_game</th>
                <td>{{ game.descriptionGame }}</td>
            </tr>
            <tr>
                <th>Released_at</th>
                <td>{{ game.releasedAt ? game.releasedAt|date('Y-m-d') : '' }}</td>
            </tr>
            <tr>
                <th>Game_cover</th>
                <td>{{ game.gameCover }}</td>
            </tr>
            <tr>
                <th>Nb_sell_game</th>
                <td>{{ game.nbSellGame }}</td>
            </tr>
        </tbody>
    </table>

    <a href="{{ path('game_index') }}">back to list</a>

    <a href="{{ path('game_edit', {'id': game.id}) }}">edit</a>

    {{ include('game/_delete_form.html.twig') }}
{% endblock %}